# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify Alma, CentOS, CentOS Stream and Rocky Linux as rhel
%if "%{__distinit}" == "a" || "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "cs" || "%{__distinit}" == "rl"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

Name:		perl-JSON
Summary:	Parse and convert to JSON (JavaScript Object Notation)
Version:	4.10
Release:	1.%{__distinit}%{__distvers}
License:	GPL-1.0-or-later OR Artistic-1.0-Perl
URL:		https://metacpan.org/release/JSON
Source0:	https://cpan.metacpan.org/modules/by-module/JSON/JSON-%{version}.tar.gz
BuildArch:	noarch
# Module Build
BuildRequires:	coreutils
BuildRequires:	findutils
BuildRequires:	make
BuildRequires:	perl-generators
BuildRequires:	perl-interpreter
BuildRequires:	perl(ExtUtils::MakeMaker)
BuildRequires:	perl(lib)
# Module Runtime
BuildRequires:	perl(B)
BuildRequires:	perl(bytes)
BuildRequires:	perl(Carp)
BuildRequires:	perl(constant)
BuildRequires:	perl(Encode)
BuildRequires:	perl(Exporter)
BuildRequires:	perl(Math::BigFloat)
BuildRequires:	perl(Math::BigInt)
BuildRequires:	perl(overload)
BuildRequires:	perl(Scalar::Util)
BuildRequires:	perl(strict)
BuildRequires:	perl(warnings)
# Test Suite
BuildRequires:	perl(charnames)
BuildRequires:	perl(Data::Dumper)
BuildRequires:	perl(JSON::XS) >= 4.00
BuildRequires:	perl(Test::More)
BuildRequires:	perl(Tie::Array)
BuildRequires:	perl(Tie::Hash)
BuildRequires:	perl(Tie::IxHash)
BuildRequires:	perl(Types::Serialiser)
BuildRequires:	perl(vars)
BuildRequires:	perl(utf8)
# Dependencies
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
Requires:	perl(B)
Requires:	perl(Encode)
Requires:	perl(Math::BigFloat)
Requires:	perl(Math::BigInt)
Requires:	perl(Scalar::Util)
Requires:	perl(warnings)

# Filter unwanted perl provides and requires
%global __provides_exclude perl\\(JSON::(Backend::PP|backportPP::Boolean|Boolean)\\)
%global __requires_exclude perl\\(JSON::backportPP(::Boolean)?\\)

%description
This module converts between JSON (JavaScript Object Notation) and Perl
data structure into each other. For JSON, see http://www.crockford.com/JSON/.

%prep
%setup -q -n JSON-%{version}

%build
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -delete
%{_fixperms} -c %{buildroot}

%check
unset PERL_JSON_BACKEND PERL_JSON_DEBUG PERL_JSON_PP_USE_B
make test

%files
%doc Changes README
%{perl_vendorlib}/JSON.pm
%{perl_vendorlib}/JSON/
%{_mandir}/man3/JSON.3*
%{_mandir}/man3/JSON::backportPP.3*
%{_mandir}/man3/JSON::backportPP::Boolean.3*
%{_mandir}/man3/JSON::backportPP::Compat5005.3*
%{_mandir}/man3/JSON::backportPP::Compat5006.3*

%changelog
* Mon Oct 10 2022 Paul Howarth <paul@city-fan.org> - 4.10-1
- Update to 4.10
  - Updated backportPP with JSON::PP 4.12
- Use SPDX-format license tag

* Mon Aug  1 2022 Paul Howarth <paul@city-fan.org> - 4.09-1
- Update to 4.09
  - Fix a test to pass under perl with core bool support

* Sun Jul 31 2022 Paul Howarth <paul@city-fan.org> - 4.08-1
- Update to 4.08
  - Updated backportPP with JSON::PP 4.11

* Fri Jun 24 2022 Paul Howarth <paul@city-fan.org> - 4.07-1
- Update to 4.07
  - Updated backportPP with JSON::PP 4.10

* Sun May 22 2022 Paul Howarth <paul@city-fan.org> - 4.06-1
- Update to 4.06
  - Updated backportPP with JSON::PP 4.09

* Fri Jan 14 2022 Paul Howarth <paul@city-fan.org> - 4.05-1
- Update to 4.05
  - Removed VERSION section in pod (GH#52)

* Sat Dec 18 2021 Paul Howarth <paul@city-fan.org> - 4.04-1
- Update to 4.04
  - Updated backportPP with JSON::PP 4.07

* Sun Jan 24 2021 Paul Howarth <paul@city-fan.org> - 4.03-1
- Update to 4.03
  - Corrected one typo in POD
  - Updated backportPP with JSON::PP 4.06
- Drop support for building with rpm < 4.9

* Fri Jun 26 2020 Paul Howarth <paul@city-fan.org> - 4.02-6
- Perl 5.32 rebuild

* Sat Feb 23 2019 Paul Howarth <paul@city-fan.org> - 4.02-1
- Update to 4.02
  - Fix a test that broke if perl was compiled with -Dquadmath (CPAN RT#128589)

* Mon Jan 21 2019 Paul Howarth <paul@city-fan.org> - 4.01-1
- Update to 4.01
  - Added boolean function/method that takes a scalar value and returns a
    boolean value

* Fri Dec  7 2018 Paul Howarth <paul@city-fan.org> - 4.00-1
- Update to 4.00
  - BACKWARD INCOMPATIBILITY: As JSON::XS 4.0 changed its policy and enabled
    allow_nonref by default, JSON::PP, and thus JSON, also enabled allow_nonref
    by default
  - Updated backportPP with JSON::PP 4.00
  - Allow PERL_JSON_PP_USE_B environmental variable to restore old number
    detection behaviour for compatibility
- RPM version resynced with upstream

* Fri Dec 22 2017 Paul Howarth <paul@city-fan.org> - 2.97.001-1
- Update to 2.97001
  - Updated backportPP with JSON::PP 2.97001
`
* Tue Nov 21 2017 Paul Howarth <paul@city-fan.org> - 2.97-1
- Update to 2.97000
  - Updated backportPP with JSON::PP 2.97000
  - Use 5 digit minor version number for a while to avoid confusion
  - Fixed is_bool to use blessed() instead of ref()

* Mon Nov 20 2017 Paul Howarth <paul@city-fan.org> - 2.96-1
- Update to 2.96
  - Fixed packaging issue
  - Updated backportPP with JSON::PP 2.96
  - Avoid use of newer Test::More features (CPAN RT#122421)

* Mon May 29 2017 Paul Howarth <paul@city-fan.org> - 2.94-1
- Update to 2.94
  - Fixed VERSION issue caused by VERSION methods added to abstract backend
    packages (CPAN RT#121892)
  - Fixed a test for perl 5.6

* Fri May 19 2017 Paul Howarth <paul@city-fan.org> - 2.93-1
- Update to 2.93
  - Add VERSION methods to (abstract) backend packages
  - Explained backward incompatibility about backend method
  - Updated VERSIONs of backportPP modules

* Tue May 16 2017 Paul Howarth <paul@city-fan.org> - 2.92-1
- Update to 2.92
  - PERL_JSON_BACKEND now accepts Cpanel::JSON::XS as well
  - Tweaked tests to support various backends
  - Made convert_blessed_universally (for Perl 5.18+) and support_by_pp less
    harmful
  - Fixed N/A exit code in Makefile.PL
  - Various documentation tweaks
  - Reworked documentation, based on the one for JSON::XS
  - Removed duplicated tests
  - Removed base.pm dependency
  - Updated backportPP with JSON::PP 2.91_04
  - Fixed not to fail tests under Perl 5.25.*
- This release by ISHIGAKI → update source URL
- Drop support for EOL distributions prior to F-13
  - Drop BuildRoot: and Group: tags
  - Drop explicit buildroot cleaning in %%install section
  - Drop explicit %%clean section

* Sun Jul 31 2016 Paul Howarth <paul@city-fan.org> - 2.90-7
- Fix FTBFS when perl is not in the minimal buildroot
- Classify buildreqs by usage
- Simplify find command using -delete
- Prefer %%global over %%define

* Fri Aug 29 2014 Paul Howarth <paul@city-fan.org> - 2.90-3
- Drop %%defattr, redundant since rpm 4.4

* Thu Oct 31 2013 Paul Howarth <paul@city-fan.org> - 2.90-1
- Update to 2.90
  - INCOMPATIBLE CHANGE (JSON version 2.90)
  - JSON.pm used to patch JSON::XS::Boolean and JSON::PP::Boolean internally at
    loading time to make these modules inherit JSON::Boolean. However, since
    JSON::XS v3.0, it use Types::Serialiser as boolean class, which breaks
    the boolean class overload features and -support_by_pp if JSON::XS v3.0 or
    later is installed.
  - JSON::true and JSON::false returned JSON::Boolean objects. As a workaround,
    they return JSON::PP::Boolean objects in this version:
    isa_ok( JSON::true, 'JSON::PP::Boolean' );
  - It also discards a feature:
    ok( JSON::true eq 'true' );
  - In other words, JSON::PP::Boolean overloads numeric only:
    ok( JSON::true == 1 );

* Fri Oct 18 2013 Paul Howarth <paul@city-fan.org> - 2.61-1
- Update to 2.61
  - $json->is_xs, $json->is_pp was completely broken (CPAN RT#75867)
  - Fixed return/or in _incr_parse (CPAN RT#86948)

* Wed Jul 17 2013 Paul Howarth <paul@city-fan.org> - 2.59-2
- Perl 5.18 rebuild

* Wed Jun 12 2013 Paul Howarth <paul@city-fan.org> - 2.59-1
- Update to 2.59
  - PUREPERL_ONLY support was not supported...  and finally remove all PP
    options from Makefile.PL
  - Recommend JSON::XS instead of conditionally requiring it
    (for example, $ cpanm --with-recommends JSON)
  - Hide more packages from PAUSE (and other stuff)
- Tweak provides filter not to filter as much

* Thu May 23 2013 Paul Howarth <paul@city-fan.org> - 2.58-1
- Update to 2.58
  - Support PUREPERL_ONLY install option (CPAN RT#84876)
    (PERL_ONLY and NO_XS are not yet removed)
  - Stop installing JSON::XS automatically on Perl 5.18

* Sat Apr  6 2013 Paul Howarth <paul@city-fan.org> - 2.57-1
- Update to 2.57
  - Fix t/x17_strange_overload.t (CPAN RT#84451)

* Fri Apr  5 2013 Paul Howarth <paul@city-fan.org> - 2.55-1
- Update to 2.55
  - Fixed t/19_incr.t on perl ≥ 5.17.10 (CPAN RT#84154)
  - Fixed some spelling
  - Enhanced documents
  - Changed backend module loading for overloaded object behavior
  - Updated JSON::BackportPP version
- BR: perl(JSON::XS) for the test suite

* Mon Jun 25 2012 Paul Howarth <paul@city-fan.org> - 2.53-5
- BR: perl(base), perl(Carp), perl(constant), perl(Data::Dumper) and perl(lib)
- Install to vendor directories
- Don't need to remove empty directories from the buildroot
- Drop support for old distributions prior to FC-3:
  - Don't need to define %%{perl_vendorlib}
  - Use DESTDIR rather than PERL_INSTALL_ROOT

* Tue Jun 28 2011 Paul Howarth <paul@city-fan.org> - 2.53-2
- Rebuild for perl 5.14.1 in Rawhide
- Fix dist tag for CentOS 6 and Scientific Linux

* Sun May 22 2011 Paul Howarth <paul@city-fan.org> - 2.53-1
- Update to 2.53
  - Fixed to_json (CPAN RT#68359)
  - Backport JSON::PP 2.27200 (fixed incr_parse decoding string more correctly
    - CPAN RT#68032)
  - Made Makefile.PL skip an installing XS question when set $ENV{PERL_ONLY} or
    $ENV{NO_XS} (CPAN RT#66820)
- Nobody else likes macros for commands

* Tue Mar  8 2011 Paul Howarth <paul@city-fan.org> - 2.51-1
- Update to 2.51 (#683052)
  - Import JSON::PP 2.27105 as BackportPP
  - Fix documentation (CPAN RT#64738)
- Use rpm 4.9 native filtering mechanism

* Thu Jan 27 2011 Paul Howarth <paul@city-fan.org> - 2.50-2
- Import from Fedora

* Thu Jan 27 2011 Paul Howarth <paul@city-fan.org> - 2.50-1
- Update to 2.50 (#665621)
  - JSON::PP split off into separate distribution and replaced with
    JSON::backportPP instead for internal use
- BR: perl(Test::Pod)
- Drop t/ from %%doc as the tests are in the -tests subpackage
- Filter private module perl(JSON::backportPP) from requires
- Filter private module perl(JSON::backportPP::Boolean) from provides
- Filter private module perl(JSON::Backend::PP) from provides
- Filter private module perl(JSON::Boolean) from provides
- Filter private module perl(JSON::PP) from provides (really JSON::backportPP)
- Filter private module perl(JSON::PP::IncrParser) from provides

* Sun Nov 21 2010 Iain Arnell <iarnell@gmail.com> - 2.27-1
- Update to latest upstream version
- Clean up spec for modern rpmbuild

* Sun May 02 2010 Marcela Maslanova <mmaslano@redhat.com> - 2.17-2
- Mass rebuild with perl 5.12.0

* Sun Feb 28 2010 Chris Weyl <cweyl@alumni.drew.edu> - 2.17-1
- Update by Fedora::App::MaintainerTools 0.004
- PERL_INSTALL_ROOT => DESTDIR
- Dropped old BR on perl(HTTP::Request)
- Dropped old BR on perl(HTTP::Response)
- Dropped old requires on perl(HTTP::Daemon)
- Dropped old requires on perl(LWP::UserAgent)
- Dropped old requires on perl(Scalar::Util)

* Wed Sep 02 2009 Chris Weyl <cweyl@alumni.drew.edu> - 2.15-5
- Adjust filtering so we don't drop the versioned perl(JSON:PP) prov

* Tue Sep 01 2009 Chris Weyl <cweyl@alumni.drew.edu> - 2.15-4
- Bump

* Mon Aug 31 2009 Chris Weyl <cweyl@alumni.drew.edu> - 2.15-3
- Update filtering

* Sun Jul 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.15-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Mon Jun 22 2009 Chris Weyl <cweyl@alumni.drew.edu> - 2.15-1
- Auto-update to 2.15 (by cpan-spec-update 0.01)

* Sun Mar 01 2009 Chris Weyl <cweyl@alumni.drew.edu> - 2.14-1
- Update to 2.14

* Thu Feb 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.12-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Thu Feb 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.12-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Sun Oct 12 2008 Chris Weyl <cweyl@alumni.drew.edu> - 2.12-1
- Update to 2.12

* Wed Jun 25 2008 Chris Weyl <cweyl@alumni.drew.edu> - 2.11-1
- Update to 2.11

* Wed May 28 2008 Chris Weyl <cweyl@alumni.drew.edu> - 2.09-1
- Update to 2.09

* Sun Mar 09 2008 Chris Weyl <cweyl@alumni.drew.edu> - 2.07-1
- Update to 2.x series before F9

* Wed Mar  5 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 1.15-2
- Rebuild for new perl

* Mon Nov 26 2007 Chris Weyl <cweyl@alumni.drew.edu> - 1.15-1
- Update to 1.15

* Sun May 13 2007 Chris Weyl <cweyl@alumni.drew.edu> - 1.14-1
- Update to 1.14

* Wed May 09 2007 Chris Weyl <cweyl@alumni.drew.edu> - 1.13-1
- Update to 1.13

* Fri May 04 2007 Chris Weyl <cweyl@alumni.drew.edu> - 1.12-1
- Update to 1.12
- Add t/ to %%doc

* Wed Apr 25 2007 Chris Weyl <cweyl@alumni.drew.edu> - 1.11-2
- Bump

* Tue Apr 24 2007 Chris Weyl <cweyl@alumni.drew.edu> - 1.11-1
- Update to 1.11

* Wed Apr 18 2007 Chris Weyl <cweyl@alumni.drew.edu> - 1.10-1
- Specfile autogenerated by cpanspec 1.69.1
